<?php

class MCGWebClient
{
	//Connector
	private $m_Con = ''; 
	//Client Secret de la aplicaion
	private $m_ClientSecret = '';
	//Client ID de la aplicaion
	private $m_ClientId = '';
	//Este es la URL que se redirecciona por la gui
	private $m_UrlRedirect = '';
	//Esta es la direccion donde se pide el tokenAccess y el userInfo
	private $m_UrlProveedoraServicio = '';
	private $m_UrlUserInfoRedirect = '';
	//Este es el grupo en el cual estara el usuario creado
	private $m_GrupoID = '';

	//Constructor donde se crearon los datos
	function __construct($urlRedirect, $clientId, $clientSecret, $grupoID, $urlAuthorizedRedirect)
	{
		//Este es la URL que se redirecciona por la gui
		if ( preg_match('http://', $urlRedirect) ){
	        $this->m_UrlRedirect = $urlRedirect;
		} else {
	        $this->m_UrlRedirect = 'http://' . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];
		}
		//Client ID
		$this->m_ClientId = $clientId;
		//Client Secret
		$this->m_ClientSecret = $clientSecret;
		//Esta es la direccion donde se pide el tokenAcces y el userInfo // a quien le hago el curl
		$this->m_UrlProveedoraServicio = 'http://192.168.124.166/MCGServices/cdagMCG.php';
		// $this->m_UrlUserInfoRedirect = 'http://demo.sendatel.com:15080/store/cdag3.php';
		$this->m_UrlUserInfoRedirect = $urlAuthorizedRedirect;
		//Este es el grupo en el cual estara el usuario creado
		$this->m_GrupoID = '29';
	}
	// Inicializador de proceso
	function init()
	{
		try
		{
			if( isset( $_GET['error'] ) && $_GET['error'] != '' )
			{
				header( "location:http://proveedores.tuidd.com.ar" );
				exit();
			}
			//Cargo el code que me devuelve la redireccion
			if (isset($_GET['code']) && $_GET['code'] != '')
			{
				$code = $_GET['code'];
			}
			else
			{
				header( "location:http://proveedores.tuidd.com.ar" );
				exit();
			}
			//Pido el acces token
			$accessTokenData = $this->getToken($code);
			$accessToken = $accessTokenData['access_token'];

			//Pido el la informacin del Usuario
			$informacionUsuario = $this->getUserInfo($code, $accessToken);

			if ( !isset($informacionUsuario['nickname']) || $informacionUsuario['nickname'] == '' )
			{
				list($name, $apelli) = explode(' ', $informacionUsuario['name']);
				$informacionUsuario['nickname'] = $name;
			}

			$this->processUserInfo($informacionUsuario, $accessTokenData);

		}catch (Exepcion $ex)
		{
			$this->printStatus('Access Token',$accessToken);
			$this->printStatus('User Info',$informacionUsuario);
		}
	}

	/* Funcion que pide el accesToken
	* code = el codigo que viene en el get
	* return = devuelve el acces token
	*/
	private	function getToken($code)
	{	
		//Armo los parametros para establecer el Curl
		$url = $this->m_UrlProveedoraServicio;
		//El Authorization : Basic es sobre el client_id y el client_secret antes del sha1
		$headers = array();
            $headers[]     = 'Authorization: Basic '.base64_encode( $this->m_ClientId . ':' . $this->m_ClientSecret );
            $headers[]     = 'Content-Type: Application/x-www-form-urlencoded';

		$arrParams = array('grant_type' => 'authorization_code', 'code' => $code, 'redirect_uri' => $this->m_UrlRedirect );
		$params = http_build_query($arrParams);
		
		//Realizo el llamado Curl
		$result = $this->sendCurl($url, $params, $headers);

		//Transformo en array el body de lo que devolvio el Curl
		$aux = (array)json_decode($result);

		print_r($aux);
		if ( $aux['access_token'] == '' )
        {
        	print 'EL ACCESS TOKEN ESTA VACIO';
        	throw new Exception("Error Durante el pedido del accessToken");
        }
		//Devuelvo solo el acces_token;
		return $aux;
	}

	/* Funcion que pide el userInfo
	* code = el codigo que viene en el get
	* access_token = acceso token pedido al accesToken
	* return = devuelve la informacion dl usuario
	*/
	private	function getUserInfo($code,$access_token)
	{
		$url = $this->m_UrlProveedoraServicio;
		$headers = array('Content-Type: application/x-www-form-urlencoded', 'Authorization: Bearer '.$access_token);
		$arrParams = array('grant_type' => 'authorization_code', 'code' => $code, 'redirect_uri' => $this->m_UrlRedirect);

		$params = http_build_query($arrParams);

		//Realizo el llamado al curl
		$result = $this->sendCurl($url, $params, $headers);
		
		//Transformo en array la devolucion del curl
		$aux = (array)json_decode($result);

		$this->printStatus('url',$this->m_UrlRedirect);

		if ( $aux['error_description']  != '' )
        {
         	throw new Exception("Error Durante el pedido del UserInfo" . $aux['error_description'] );
        }
		return $aux;
	}

	/* Esta función sirve para procesar los datos del usuario. 
	*  Que hacer con esos datos depende del poveedor.
	*  En este caso se realiza un redirect al servicio. 
	*/
	private function processUserInfo($user_info, $access_token) 
	{
		$clientInfo = base64_encode( $this->m_ClientId . ':' . $this->m_ClientSecret );
		$token_access = $access_token['access_token'];
		$token_id = $access_token['id_token'];

		// Agrego la información al array de user info
		$user_info['client_info']  = $clientInfo;
		$user_info['access_token']  = $token_access;
		$user_info['id_token']  = $token_id;
	
		$msisdn = $user_info['phone_number'];
		if ($msisdn == '') {
			throw new Exception("Información de teléfono faltante");
		}
		
		print '<pre>'.print_r($this->m_UrlUserInfoRedirect, true).'</pre>';
		$url = $this->m_UrlUserInfoRedirect . '?msisdn='. $msisdn .'&clave=store&forzar_inicio=true';

		$jsonString = json_encode( $user_info );
		$dataArray64 = base64_encode( $jsonString );
		
		header('Location: '.$url.'&data='.$dataArray64);
	}
	

	/* Esta funcion es la que esta encargada de hacer los envios por curl y transmitir la informacion
	*/
	private	function sendCurl($url,$params, $headers)
	{
		
		$params = urldecode($params);

		$ch = curl_init();

		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HTTPGET, FALSE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $params);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false);
               
        curl_setopt($ch, CURLOPT_HEADER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER,  $headers);

        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

        $response = curl_exec($ch);
        $header_size     = curl_getinfo($ch, CURLINFO_HEADER_SIZE);
        $responseBody    = substr($response, $header_size);
        curl_close($ch);

        if ( curl_error($ch) )
        {
        	throw new Exception("Error Durante el envio de Curl");
        }
        return $responseBody;
	}	

	private function getServicesToken($user_info) {

	}

	private function validateUser($user_info) {

	}

	/* Actualizar la versión del SDK
	*/
    private function updateSDK() {
    	// $url = '';
    	// $version = read_version();
    	// // , $version);
    	// $needUpdate = check_version($url);

    	// if ( $needUpdate ) {
    	// 	download_new_version();
    	// }
    }

    private function printStatus($texto,$valor)
    {
    	echo "--> $texto";
		echo '<pre>';print_r($valor);echo  '</pre>';
    }

}

$configs = parse_ini_file( 'mcg.conf' );

$urlRedirect = get_option('mcg_option_url');
$urlAuthorizedRedirect = get_option('mcg_option_authorized_redirect_uri');
$clientId = get_option('mcg_option_cient_id');
$clientSecret = get_option('mcg_option_secret');

//Este es el grupo en el cual estara el usuario creado
$grupoID = '';

$var = new MCGWebClient($urlRedirect, $clientId, $clientSecret,
                        $grupoID, $urlAuthorizedRedirect);
$var->init();

?>
